config/routes.rb
#     Copyright 2016 Netflix, Inc.
#
#     Licensed under the Apache License, Version 2.0 (the "License");
#     you may not use this file except in compliance with the License.
#     You may obtain a copy of the License at
#
#         http://www.apache.org/licenses/LICENSE-2.0
#
#     Unless required by applicable law or agreed to in writing, software
#     distributed under the License is distributed on an "AS IS" BASIS,
#     WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#     See the License for the specific language governing permissions and
#     limitations under the License.

require 'sidekiq/web'

class ActionDispatch::Routing::Mapper
  def draw_custom
    ["custom/config/routes.rb", "../custom/config/routes.rb"].each do |filename|
      instance_eval(File.read(Rails.root.join(filename))) if File.file?(filename)
    end
    
  end
end

Scumblr::Application.routes.draw do

  draw_custom

  if(User.devise_modules.include?(:omniauthable))
    devise_for :users , :controllers => { :omniauth_callbacks => "users/omniauth_callbacks" }
    match '/users/auth/openid_connect/callback' => 'users/omniauth_callbacks#openid_connect_callback', via: [:get, :post]
    match '/users/auth/openid_connect' => 'users/omniauth_callbacks#openid_connect', via: [:get, :post], as: "openid_connect"
  else
    devise_for :users
  end

  resources :users do
    member do
      post 'toggle_admin'
    end
  end

  resources :system_metadata
  resources :events, only: [:index, :show] do
    collection do
      post 'search' => 'events#index'
      get 'search' => 'events#index'
    end

  end
  resources :flags

  get "user_saved_filters/create"
  get "user_saved_filters/destroy"
  get "saved_filters/new"
  get "saved_filters/destroy"

  resources :saved_filters do
    member do
      post :add
      post :remove
    end
  end



  resources :results do
    collection do
      post 'update_multiple'
      post 'bulk_add'
      post 'search' => 'results#index'
      get 'search' => 'results#index'
      get 'tags/:tag', to: 'results#index', as: :tag
      get 'dashboard'
      get 'workflow_autocomplete'
      post 'update_table_columns'

      get 'expandall', to: 'results#expandall'
      get 'show', to: 'results#show', as: :show_by_name
      get 'expandvulns', to: 'results#expandvulns'
      get 'expandclosedvulns', to: 'results#expandclosedvulns'
      post 'create_vulnerability', to: 'results#create_vulnerability'
    end

    member do
      post 'change_status/:status_id'=>"results#update_status", as: 'update_status'
      post 'comment'  => 'results#comment', :as=> :comment
      post 'tag'  => 'results#tag'
      post 'flag'  => 'results#flag'
      post 'action/:result_flag_id/step/:stage_id'  => 'results#action', as: 'action'
      post 'assign'  => 'results#assign'
      post 'subscribe'  => 'results#subscribe'
      post 'unsubscribe'  => 'results#unsubscribe'
      delete 'tags/:tag_id', to: 'results#delete_tag', as: :delete_tag
      post :add_attachment
      delete 'attachment/:attachment_id', to: 'results#delete_attachment', as: :delete_attachment
      post 'generate_screenshot' => "results#generate_screenshot"
      post 'update_screenshot'
      get 'update_screenshot'
      match 'update_metadata', via: [:get, :post]
      match 'get_metadata', via: [:get, :post]
      get 'summary', to: 'results#summary'
      
      match 'render_metadata_partial', via: [:get, :post]
    end


  end

  resources :tags, only: :index

  resources :tasks do
    collection do
      get 'options', to: 'task_types#options'
      get 'run', to: 'tasks#run'
      post 'bulk_update'
      get 'expandall', to: 'tasks#expandall'
      get :events
    end


    member do
      get 'run', to: 'tasks#run'
      get 'get_metadata'
      post 'enable', to: 'tasks#enable'
      post 'disable', to: 'tasks#disable'
      get 'summary', to: 'tasks#summary'

    end

    member do
      get 'options', to: 'task_types#options'
    end
  end

  resources :statuses do
    member do
      post 'set_default'
    end
  end

  get 'status', to: 'status#status'
  get 'about', to: 'status#about'

  root to: "results#index"

  admin_constraint = lambda do |request|
    request.env['warden'].authenticate? && request.env['warden'].user.admin?
  end

  constraints admin_constraint do
    mount Workflowable::Engine => "/workflowable", as: :workflowable
    mount Sidekiq::Web => '/sidekiq'
    get 'errors', :to => "event_groups#index"
    get 'about', to: 'status#about'
  end

end

app/controllers/statuses_controller.rb
#     Copyright 2016 Netflix, Inc.
#
#     Licensed under the Apache License, Version 2.0 (the "License");
#     you may not use this file except in compliance with the License.
#     You may obtain a copy of the License at
#
#         http://www.apache.org/licenses/LICENSE-2.0
#
#     Unless required by applicable law or agreed to in writing, software
#     distributed under the License is distributed on an "AS IS" BASIS,
#     WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#     See the License for the specific language governing permissions and
#     limitations under the License.


class StatusesController < ApplicationController
  before_filter :load_status, only: [:show, :edit, :update, :destroy, :set_default]
  authorize_resource
  # GET /statuses
  # GET /statuses.json
  def index
    @statuses = Status.all

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @statuses }
    end
  end

  # GET /statuses/1
  # GET /statuses/1.json
  def show

    respond_to do |format|
      format.html # show.html.erb
      format.json { render json: @status }
    end
  end

  # GET /statuses/new
  # GET /statuses/new.json
  def new
    @status = Status.new

    respond_to do |format|
      format.html # new.html.erb
      format.json { render json: @status }
    end
  end

  # GET /statuses/1/edit
  def edit

  end

  # POST /statuses
  # POST /statuses.json
  def create
    @status = Status.new(status_params)

    respond_to do |format|
      if @status.save
        format.html { redirect_to @status, notice: 'Status was successfully created.' }
        format.json { render json: @status, status: :created, location: @status }
      else
        format.html { render action: "new" }
        format.json { render json: @status.errors, status: :unprocessable_entity }
      end
    end
  end

  # PUT /statuses/1
  # PUT /statuses/1.json
  def update


    respond_to do |format|
      if @status.update_attributes(status_params)
        format.html { redirect_to @status, notice: 'Status was successfully updated.' }
        format.json { head :no_content }
      else
        format.html { render action: "edit" }
        format.json { render json: @status.errors, status: :unprocessable_entity }
      end
    end
  end

  def set_default
    if(@status)
      @status.default = true
      @status.save
      respond_to do |format|
        format.html { redirect_to statuses_url, notice: "Status updated successfully" }
        format.json { head :no_content }
      end
    else
      respond_to do |format|
        format.html { redirect_to statuses_url, notice: "Could not update status" }
        format.json { head :no_content }
      end
    end

    

  end

  # DELETE /statuses/1
  # DELETE /statuses/1.json
  def destroy

    @status.destroy

    respond_to do |format|
      format.html { redirect_to statuses_url }
      format.json { head :no_content }
    end
  end

  private

  def load_status
    @status = Status.find(params[:id])
  end

  def status_params
    params.require(:status).permit(:name, :closed, :is_invalid, :default)
  end




end

app/helpers/statuses_helper.rb
#     Copyright 2016 Netflix, Inc.
#
#     Licensed under the Apache License, Version 2.0 (the "License");
#     you may not use this file except in compliance with the License.
#     You may obtain a copy of the License at
#
#         http://www.apache.org/licenses/LICENSE-2.0
#
#     Unless required by applicable law or agreed to in writing, software
#     distributed under the License is distributed on an "AS IS" BASIS,
#     WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#     See the License for the specific language governing permissions and
#     limitations under the License.


module StatusesHelper
end

app/views/statuses/_form.html.erb
<%= form_for(@status) do |f| %>
  <% if @status.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@status.errors.count, "error") %>
        prohibited this status from being saved:</h2>
      <ul>
        <% @status.errors.full_messages.each do |msg| %>
          <li><%= msg %></li>
        <% end %>
      </ul>
    </div>
  <% end %>
  <div class="field">
    <%= f.label :name %><br />
    <%= f.text_field :name %>
  </div>
  <div class="field">
    <%= f.label :closed do %>Closed
      <span data-tooltip class="has-tip fi-info" title="Should the status indicate workflow is completed?"></span>
    <% end %>
    <%= f.check_box :closed %>
  </div>
  <div class="field">
    <%= f.label :invalid do %>
      Invalid
      <span data-tooltip class="has-tip fi-info" title="Should the result be considered invalid (such as a false positive)" class="fi-info"></span>
    <% end %>
    <%= f.check_box :is_invalid %>
  </div>
  <div class="field">
    <%= f.label :default do %>
      Default
      <span data-tooltip class="has-tip fi-info" title="Should new result automatically be put into this status?" class="fi-info"></span>
    <% end %>
    <%= f.check_box :default %>
  </div>

  <div class="actions">
    <%= f.submit class: "button" %>
    <%= link_to 'Back', statuses_path, class: "button secondary" %>
  </div>
<% end %>

app/views/statuses/edit.html.erb
<h1>Editing status</h1>
<%= render 'form' %>

app/views/statuses/index.html.erb
<table>
  <tr>
    <th>Name</th>
    <th>Closed</th>
    <th>Invalid</th>
    <th>Default</th>
    <th></th>
  </tr>
  <% @statuses.each do |status| %>
    <tr>
      <td><%= link_to status.name, status_path(status) %></td>
      <td><%= status.closed == true %></td>
      <td><%= status.is_invalid == true %></td>
      <td><%= status.default == true %></td>
      <td>
        <%= link_to 'Edit', edit_status_path(status) , class: "button tiny" %>
        <%= link_to 'Destroy', status, method: :delete, data: { confirm: 'Are you sure?' }, class: "button tiny alert" %>
        <%= link_to 'Make Default', set_default_status_path(status), method: :post, class: "button tiny" if !status.default %>
      </td>
    </tr>
  <% end %>
</table>
<br />
<%= link_to 'New Status', new_status_path, class: "button" %>

app/views/statuses/new.html.erb
<h1>New status</h1>
<%= render 'form' %>

app/views/statuses/show.html.erb
<p id="notice"><%= notice %></p>
<p>
  <b>Name:</b>
  <%= @status.name %>
</p>
<%= link_to 'Edit', edit_status_path(@status), class: "button" %>
<%= link_to 'Back', statuses_path, class: "button secondary" %>